/******************************************************************************/
/* Files to Include                                                           */
/******************************************************************************/

#include <htc.h>           /* Global Header File */
#include <stdint.h>        /* For uint8_t definition */
#include <stdbool.h>       /* For true/false definition */

#include "system.h"        /* System funct/params, like osc/peripheral config */
#include "user.h"          /* User funct/params, such as InitApp */

/******************************************************************************/
/* User Global Variable Declaration                                           */
/******************************************************************************/

unsigned char const decode_phase_porta[]={0b00000010,0b00000010,0b00000010,0b00000010,0b00000000,0b00000010,0b00000010,0b00000010};
unsigned char const decode_phase_portb[]={0b10000001,0b11000001,0b01000001,0b11000001,0b11000001,0b11000001,0b11000000,0b11000001};
unsigned char const decode_digit_porta[]={0b1101,0b0001,0b1001,0b1001,0b0101,0b1100,0b1100,0b1001,\
 0b1101,0b1101,0b1101,0b0100,0b1100,0b0001,0b1100,0b1100,\
 0b0000,0b0101,0b0100,0x00,\
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,\
 0x00,0x00,0x00,0x00};

unsigned char const decode_digit_portb[]={0b010110,0b010000,0b100110,0b110100,0b110000,0b110100,0b110110,0b110000,\
 0b110110,0b110100,0b110010,0b110110,0b000110,0b110110,0b100110,0b100010,\
 0b100000,0b110010,0b000110,0x00,0x00,0x00,0x00,0x00,\
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};

unsigned char digits[]={0,0,0,0};

unsigned char phase=4;
unsigned char curr_digit;

unsigned char time_secs1=0;
unsigned char time_secs10=0;
unsigned char time_mins1=0;
unsigned char time_mins10=0;

unsigned char vporta,vportb;

/* i.e. uint8_t <variable_name>; */

/******************************************************************************/
/* Main Program                                                               */
/******************************************************************************/

void refresh(void)
{
    curr_digit=digits[phase>>1];
    vporta=decode_digit_porta[curr_digit];
    vportb=decode_digit_portb[curr_digit];
    vporta|=decode_phase_porta[phase];
    vportb|=decode_phase_portb[phase];

    PORTA=vporta;
    PORTB=vportb;
}

void add_sec()
{
    TMR0=0;
    time_secs1++;
    if(time_secs1==10){time_secs1=0;time_secs10++;};
    if(time_secs10==6){time_secs10=0;time_mins1++;};
    if(time_mins1==10){time_mins1=0;time_mins10++;};
    if(time_mins10==6){time_mins10=0;};
}

uint8_t main(void)
{
    /* Configure the oscillator for the device */
//    ConfigureOscillator();

    /* Initialize I/O and Peripherals for application */
    InitApp();

    /* TODO <INSERT USER APPLICATION CODE HERE> */

    while(1)
    {
        if (TMR0==0x20)add_sec();

         if((time_mins1>0)||(time_mins10>0))
         {
          if(TMR0<3){
           digits[2]=time_secs10;
           digits[3]=time_secs1;
          }else
          {
           digits[2]=time_mins10;
           digits[3]=time_mins1;
          }
         }else
         {
          digits[2]=time_secs10;
          digits[3]=time_secs1;
         }
        
        refresh();
        phase+=2;
        if(phase==8)phase=4;
    }

}

